Debian Bug report logs - #388761
initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system

version graph

Package: initscripts; Maintainer for initscripts is Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>; Source for initscripts is src:sysvinit.

Reported by: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>

Date: Fri, 22 Sep 2006 13:03:11 UTC

Severity: important

Found in version sysvinit/2.86.ds1-20

Fixed in version sysvinit/2.86.ds1-35

Done: Petter Reinholdtsen <pere@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Tim Phipps <tim@phipps-hutton.freeserve.co.uk>:
New Bug report received and forwarded. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 13:47:42 +0100
Package: initscripts
Version: 2.86.ds1-20
Severity: important

Setting this to important since it won't break simple systems.
I'm using the initramfs boot=nfs aproach to run a diskless system. I
have to remove eth0 from the auto line in /etc/network/interfaces
otherwise "ifup -a" hangs the system. I have this in
/etc/network/interfaces:

# This file describes the network interfaces available on your system
# and how to activate them. For more information, see interfaces(5).

# The loopback network interface.
auto lo
iface lo inet loopback

# The primary network interface.
# This is already done by the nfs boot scripts so the auto line is
# disabled.
#auto eth0
iface eth0 inet dhcp

EOF

And now if-up -a doesn't run /etc/network/if-up.d/mountnfs.
I can work around this by adding a fantasy interface to
/etc/network/interfaces:

auto eth1
iface eth1 inet static
  address 192.168.1.2
  gateway 192.168.1.1
  netmask 255.255.255.0

which works even though there is no eth1. I don't know what the real fix
is, I'd just put /etc/init.d/mountnfs.sh back so it runs just after
/etc/init.d/networking.

-- System Information:
Debian Release: testing/unstable
  APT prefers testing
  APT policy: (500, 'testing')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.17-2-686
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)

Versions of packages initscripts depends on:
ii  debianutils                  2.17        Miscellaneous utilities specific t
ii  e2fsprogs                    1.39-1      ext2 file system utilities and lib
ii  libc6                        2.3.6.ds1-4 GNU C Library: Shared libraries
ii  lsb-base                     3.1-15      Linux Standard Base 3.1 init scrip
ii  mount                        2.12r-10    Tools for mounting and manipulatin

initscripts recommends no packages.

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #10 received at 388761@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>, 388761@bugs.debian.org
Subject: Re: Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 15:17:32 +0200
[Tim Phipps]
> Setting this to important since it won't break simple systems.
> I'm using the initramfs boot=nfs aproach to run a diskless system. I
> have to remove eth0 from the auto line in /etc/network/interfaces
> otherwise "ifup -a" hangs the system. I have this in
> /etc/network/interfaces:

Why do ifup -a hang on your system?  This seem to be the most obvious
bug to fix to solve this issue.

Friendly,
-- 
Petter Reinholdtsen



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Tim Phipps <tim@phipps-hutton.freeserve.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #15 received at 388761@bugs.debian.org (full text, mbox):

From: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>
To: Petter Reinholdtsen <pere@hungry.com>
Cc: 388761@bugs.debian.org
Subject: Re: Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 14:56:07 +0100
On Friday 22 September 2006 14:17, Petter Reinholdtsen wrote:
> [Tim Phipps]
>
> Why do ifup -a hang on your system?  This seem to be the most obvious
> bug to fix to solve this issue.
It's hard to tell since it locks totally. I think ifup is deconfiguring the 
interface before it starts to up it. If it does anything after deconfiguring 
the interface (like looking for a pre-configure script) it will fail since 
any file access (even stating /dev/null since / will be locked) will lock 
things up. Whatever it is doing it's causing the root nfs-mount to not work. 

It would be better if "ifup -a" would just skip any interfaces that are 
already up. If that can be done then maybe this is a bug for ifup. Even so it 
must execute /etc/network/if-up.d scripts.

Thinking about this some more. Moving nfsmount to /etc/network/if-up.d isn't 
going to be nice for people with more than one network interface. My reading 
of the ifup man page says that the scripts are run for _each_ interface 
brought up (with some env variables to say which interface). The new nfsmount 
script is going to be run twice. Worse, if you have mounts from both 
interfaces it will run the nfsmount script after the first interface is up 
but before the second interface is up. I don't know what would happen then, I 
guess you're about to find out.

What's the problem with having the old systems of an init.d script running 
after ifup?

Cheers,
Tim.



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #20 received at 388761@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>
Cc: 388761@bugs.debian.org
Subject: Re: Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 16:04:30 +0200
[Tim Phipps]
> What's the problem with having the old systems of an init.d script
> running after ifup?

Some times it take too long for the network to start working, so
mountnfs.sh would always fail.  See #360123.

Friendly,
-- 
Petter Reinholdtsen



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Tim Phipps <tim@phipps-hutton.freeserve.co.uk>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #25 received at 388761@bugs.debian.org (full text, mbox):

From: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>
To: Petter Reinholdtsen <pere@hungry.com>
Cc: 388761@bugs.debian.org
Subject: Re: Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 15:38:47 +0100
On Friday 22 September 2006 15:04, Petter Reinholdtsen wrote:
> [Tim Phipps]
>
> > What's the problem with having the old systems of an init.d script
> > running after ifup?
>
> Some times it take too long for the network to start working, so
> mountnfs.sh would always fail.  See #360123.

Hmm, tough choices to make. Though I don't think it's a good idea to have nfs 
mounts in /etc/fstab marked as auto if they depend on hotplug network 
interfaces. I think in that case you should have a hotplug script that mounts 
the file systems after the interface is up. /etc/fstab is the wrong place for 
those file systems since it doesn't describe which interface is used. If 
you've got nfs mounts in /etc/fstab that should imply they work with the boot 
time available network interfaces.
>
> Friendly,



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Petter Reinholdtsen <pere@hungry.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #30 received at 388761@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@hungry.com>
To: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>
Cc: 388761@bugs.debian.org
Subject: Re: Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 17:28:55 +0200
[Tim Phipps]
> Though I don't think it's a good idea to have nfs mounts in
> /etc/fstab marked as auto if they depend on hotplug network
> interfaces.

I am not talking about hotplug network interfaces.  I am talking about
network interfaces available at boot time where it just take too long
to handshake with the switch and get a dhcp reponse.  And those we
should handle.  And we do that with the new nfs mounting code, as long
as ifup is used to take up the network.  So your problem need to be
solved by getting ifup to do what it is supposed to do.  Any idea why
it isn't?  I've noticed some locking issues in ifupdown which I hope
to address when an writable tmpfs is available for it early enough in
the boot.

Friendly,
-- 
Petter Reinholdtsen



Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Henrique de Moraes Holschuh <hmh@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #35 received at 388761@bugs.debian.org (full text, mbox):

From: Henrique de Moraes Holschuh <hmh@debian.org>
To: Tim Phipps <tim@phipps-hutton.freeserve.co.uk>, 388761@bugs.debian.org
Cc: Petter Reinholdtsen <pere@hungry.com>
Subject: Re: [Pkg-sysvinit-devel] Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Fri, 22 Sep 2006 16:57:13 -0300
On Fri, 22 Sep 2006, Tim Phipps wrote:
> Hmm, tough choices to make. Though I don't think it's a good idea to have nfs 
> mounts in /etc/fstab marked as auto if they depend on hotplug network 
> interfaces. I think in that case you should have a hotplug script that mounts 

We ought to keep fstab as the place for all this filesystem information, but
also mark the ones that are to be mounted by async usespace (aka udev right
now), in a udev-enabled system (in a non-udev system, initscripts have to
mount them).

-- 
  "One disk to rule them all, One disk to find them. One disk to bring
  them all and in the darkness grind them. In the Land of Redmond
  where the shadows lie." -- The Silicon Valley Tarot
  Henrique Holschuh



Blocking bugs of 388761 added: 388814 Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>:
Bug#388761; Package initscripts. Full text and rfc822 format available.

Acknowledgement sent to Brian Cluff <brian@snaptek.com>:
Extra info received and forwarded to list. Copy sent to Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>. Full text and rfc822 format available.

Message #42 received at 388761@bugs.debian.org (full text, mbox):

From: Brian Cluff <brian@snaptek.com>
To: 388761@bugs.debian.org
Subject: Re: Bug#388761: initscripts: Moving NFS mounts to /etc/network/if-up.d/mountnfs breaks my diskless system
Date: Thu, 05 Oct 2006 08:38:28 -0700
I just ran into this same problem my self.  The problem seem to be 
caused by having an older diskless system where the old way of doing 
things was to compile a big fat kernel with all the modules you needed 
to boot and to run the system compiled in and running without an 
initrd.img.  If you do that, when the interface goes to try and get an 
IP (for the second time) it looses any access it had to it's network 
mounted root directory and therefore can't mount anything and freezes.

The fix would seem to be to change your kernel to a stock one along with 
loading its initrd.img so that you still have access to a mount command 
if you loose your IP.  (I makes kernel upgrades easier too)

Brian



Tags added: pending Request was from Petter Reinholdtsen <pere@hungry.com> to control@bugs.debian.org. Full text and rfc822 format available.

Reply sent to Petter Reinholdtsen <pere@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Tim Phipps <tim@phipps-hutton.freeserve.co.uk>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #49 received at 388761-close@bugs.debian.org (full text, mbox):

From: Petter Reinholdtsen <pere@debian.org>
To: 388761-close@bugs.debian.org
Subject: Bug#388761: fixed in sysvinit 2.86.ds1-35
Date: Sun, 26 Nov 2006 19:17:05 +0000
Source: sysvinit
Source-Version: 2.86.ds1-35

We believe that the bug you reported is fixed in the latest version of
sysvinit, which is due to be installed in the Debian FTP archive:

initscripts_2.86.ds1-35_i386.deb
  to pool/main/s/sysvinit/initscripts_2.86.ds1-35_i386.deb
sysv-rc_2.86.ds1-35_all.deb
  to pool/main/s/sysvinit/sysv-rc_2.86.ds1-35_all.deb
sysvinit-utils_2.86.ds1-35_i386.deb
  to pool/main/s/sysvinit/sysvinit-utils_2.86.ds1-35_i386.deb
sysvinit_2.86.ds1-35.diff.gz
  to pool/main/s/sysvinit/sysvinit_2.86.ds1-35.diff.gz
sysvinit_2.86.ds1-35.dsc
  to pool/main/s/sysvinit/sysvinit_2.86.ds1-35.dsc
sysvinit_2.86.ds1-35_i386.deb
  to pool/main/s/sysvinit/sysvinit_2.86.ds1-35_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 388761@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Petter Reinholdtsen <pere@debian.org> (supplier of updated sysvinit package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Sun, 26 Nov 2006 20:06:00 +0100
Source: sysvinit
Binary: sysv-rc sysvinit-utils sysvinit initscripts
Architecture: source i386 all
Version: 2.86.ds1-35
Distribution: unstable
Urgency: medium
Maintainer: Debian sysvinit maintainers <pkg-sysvinit-devel@lists.alioth.debian.org>
Changed-By: Petter Reinholdtsen <pere@debian.org>
Description: 
 initscripts - Scripts for initializing and shutting down the system
 sysv-rc    - System-V-like runlevel change mechanism
 sysvinit   - System-V-like init utilities
 sysvinit-utils - System-V-like utilities
Closes: 388761 391673 392861 393532 397525 398644 399715
Changes: 
 sysvinit (2.86.ds1-35) unstable; urgency=medium
 .
   * Medium urgency as it solve some RC bugs in etch.
   * Make sure init.d/umountfs umount tmpfs file systems in order of
     decreasing length, to avoid problems on systems with chroots.
     Patch from Peter Rabbitson.  (Closes: #391673)
   * Add boot option ASYNCMOUNTNFS=no to get the old init.d/mountnfs.sh
     behaviour until ifup work properly with / on NFS.  The default is
     'yes' as it has the highest chance of success for non-diskless machines.
     It is also useful for machines with multiple network cards.
     (Closes: #388761, #393532)
   * Fix syslogging code in if-up.d/mountnfs to find logger if it exist.
     Patch from John Morrissey.  (Closes: #398644)
   * Avoid file descriptor leak to mount in init.d/mtab.sh.  Based
     on patch from David Härdeman. (Closes: #397525).
   * Fix typo in message added in 91_sulogin_lockedpw.dpatch.
     Thanks to Robert Bihlmeyer.  (Closes: #399715)
   * Undo use of fuser to kill processes in umountnfs before unmounting
     partitions, as it will kill init and /etc/init.d/rc during
     shutdown if root is on NFS or tmpfs file systems are bind-mounted
     into chroots.  Use sendsigs and move it before umountnfs, and thus
     reopen bugs #258420, #367944.  (Closes: #392861)
Files: 
 d5d52d67f816bed777e0c4ab83c250b4 968 admin required sysvinit_2.86.ds1-35.dsc
 45cb6cbc648965379c5e52c97ca50edc 132660 admin required sysvinit_2.86.ds1-35.diff.gz
 7c986e5e473377c904bdcca143b9c6ce 106956 admin required sysvinit_2.86.ds1-35_i386.deb
 99b567d6a75ae2b205b3220b321b4365 65302 admin required sysvinit-utils_2.86.ds1-35_i386.deb
 cfc4f3e689e9f0c497ed90f742ebfc6c 59176 admin required initscripts_2.86.ds1-35_i386.deb
 4d73bea62d4edd88af4d390e534ce69c 55706 admin required sysv-rc_2.86.ds1-35_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.5 (GNU/Linux)

iD8DBQFFaech20zMSyow1ykRApa1AJ9NnOIUKM1Y227Vttc7k9asGI6CWQCeJlEr
9AYTfxV4yeuuJvdaWKPUCuo=
=0ugX
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 26 Jun 2007 03:47:39 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 15:45:39 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.